package com.kangda.pd;

import java.io.BufferedInputStream;
import java.io.FileInputStream;

import com.kangda.pd.CtrlC.RunWhenShuttingDown;

import javazoom.jl.player.Player;

public class Mp3Player {
	
	private String filename;
    private Player player; 
    
    private volatile boolean keepOn = true;

    public class RunWhenShuttingDown extends Thread {
        public void run() {
            System.out.println("Control-C caught. Shutting down...");
            keepOn = false;
            try {
                Thread.sleep(2000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
    
    // constructor that takes the name of an MP3 file
    public Mp3Player(String filename) {
        this.filename = filename;
    }

    public void close(){ 
    	if (player != null) 
    		player.close(); 
    }

    // play the MP3 file to the sound card
    public void play() {
        try {
            FileInputStream fis     = new FileInputStream(filename);
            BufferedInputStream bis = new BufferedInputStream(fis);
            player = new Player(bis);
        }
        catch (Exception e) {
            System.out.println("Problem playing file " + filename);
            System.out.println(e);
        }

        // run in new thread to play in background
        new Thread() {
            public void run() {
                try { player.play(); }
                catch (Exception e) { System.out.println(e); }
            }
        }.start();

    }


    // test client
    public static void main(String[] args) throws InterruptedException {
       
    	String filename = args[0];
        Mp3Player mp3 = new Mp3Player(filename);
        mp3.play();

        Runtime.getRuntime().addShutdownHook(mp3.new RunWhenShuttingDown());
        
        // do whatever computation you like, while music plays
        while(mp3.keepOn){
        	System.out.println("running...");
            Thread.sleep(30);
        }

        System.out.println("prepare to stop...");
        // when the computation is done, stop playing it
        mp3.close();
    	
    	//new CtrlC().runProgram();
    }

}
